<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE xsl:stylesheet [
<!ENTITY copy "&#0169;">
]>
<xsl:stylesheet
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xmlns="http://www.w3.org/TR/REC-html40">

<xsl:output method="html"/>

<xsl:template match="/">
   <HTML>
   <HEAD>
      <TITLE><xsl:call-template name="title"/></TITLE>
      <META NAME="keywords">
         <xsl:attribute name="CONTENT">
            <xsl:value-of select="article/keywords"/>,
         </xsl:attribute>
      </META>
   </HEAD>
   <BODY>
      <P><B><xsl:call-template name="title"/></B></P>
      <P><B>Table of Contents</B></P>
      <UL>
         <xsl:for-each select="article/section/title">
            <LI><A>
               <xsl:attribute name="HREF">#<xsl:value-of select="generate-id()"/>
               </xsl:attribute>
               <xsl:value-of select="."/>
            </A></LI>
         </xsl:for-each>
      </UL>
      <xsl:apply-templates/>
      <P>Copyright &copy; <xsl:value-of select="article/copyright"/></P>
   </BODY>
   </HTML>
</xsl:template>

<xsl:template name="title">
   <xsl:value-of select="/article/title"/> (
   <xsl:value-of select="/article/date"/> )
</xsl:template>

<xsl:template match="section/title">
   <P><I><A>
      <xsl:attribute name="NAME">
         <xsl:value-of select="generate-id()"/>
      </xsl:attribute>
      <xsl:apply-templates/>
   </A></I></P>
</xsl:template>

<xsl:template match="url">
   <A TARGET="_blank">
      <xsl:attribute name="href">
         <xsl:value-of select="."/>
      </xsl:attribute>
      <xsl:value-of select="."/>
   </A>
</xsl:template>

<xsl:template match="url[@protocol='mailto']">
   <A>
      <xsl:attribute name="href">mailto:<xsl:value-of select="."/>
      </xsl:attribute>
      <xsl:value-of select="."/>
   </A>
</xsl:template>

<xsl:template match="p">
   <P><xsl:apply-templates/></P>
</xsl:template>

<xsl:template match="article/title | abstract | date |
                     keywords | copyright"/>

</xsl:stylesheet>