// currency code
var BEF = 0,   // Belgian franc
    USD = 1,   // US dollars
    CAD = 2;   // Canadian dollars

// returns the code associated with a currency string
function getCurrencyCode(currency)
{
   if(currency == "bef")
	  return BEF;
   else if(currency == "usd")
	  return USD;
   else if(currency == "cad")
      return CAD;
   else
      return -1;
}

function convert(form,xmldocument)
{
   var pricesfname = form.prices.value,
       ratesfname = form.rates.value;
       output = form.output,
       rates = new Array(3);

   output.value = "";

   var document = parse(ratesfname,xmldocument),
       topLevel = document.documentElement;
   searchRate(topLevel,rates);

   document = parse(pricesfname,xmldocument);
   topLevel = document.documentElement;
   walkNode(topLevel,output,rates);
}

function parse(uri,xmldocument)
{
   xmldocument.async = false;
   xmldocument.load(uri);
   
   if(xmldocument.parseError.errorCode != 0)
      alert(xmldocument.parseError.reason);

   return xmldocument;
}

function searchRate(node,rates)
{
   if(node.nodeType == 1)
   {
      if(node.nodeName == "rate")
         walkRate(node,rates)
      var children,
          i;
      children = node.childNodes;
      for(i = 0;i < children.length;i++)
         searchRate(children.item(i),rates);
   }
}

function walkRate(node,rates)
{
   if(node.attributes != null)
   {
      var attr = node.attributes.getNamedItem("currency");
      var currency = getCurrencyCode(attr.value),
          rate = node.attributes.getNamedItem("rate");
      if(currency != -1)
         rates[currency] = rate.value;
   }
}

function walkNode(node,output,rates)
{
   if(node.nodeType == 1)
   {
      if(node.nodeName == "product")
         walkProduct(node,output,rates);
      else
	  {
         var children,
             i;
         children = node.childNodes;
         for(i = 0;i < children.length;i++)
            walkNode(children.item(i),output,rates);
      }
   }
}

function walkProduct(node,output,rates)
{
   if(node.nodeType == 1 && node.nodeName == "product")
   {
      var price,
	      name,
		  children,
          i;
      children = node.childNodes;
      for(i = 0;i < children.length;i++)
	  {
	     var child = children.item(i);
	     if(child.nodeType == 1)
		 {
		    if(child.nodeName == "price")
			   price = walkPrice(child,rates);
			else if(child.nodeName == "name")
			   name = getText(child);
		 }
	  }
	  output.value += name + ": " + price + "\r";
   }
}

function walkPrice(node,rates)
{
   if(node.attributes != null)
   {
      var attr = node.attributes.getNamedItem("currency"),
	      currency = getCurrencyCode(attr.value);
      if(currency != -1)
         return getText(node) * rates[currency];
   }
}

function getText(node)
{
   return node.firstChild.data;
}