protected void doGet(HttpServletRequest request,
                     HttpServletResponse response)
   throws ServletException, IOException
{
   response.setContentType("application/xml");
   Writer writer = response.getWriter();
   String sqlDriver = getInitParameter("sql.driver"),
          sqlURL = getInitParameter("sql.url"),
          sqlUser = getInitParameter("sql.user"),
          sqlPassword = getInitParameter("sql.password"),
          merchant = getInitParameter("merchant");
   writer.write("<?xml version=\"1.0\"?>");
   writer.write("<products merchant=\"");
   writer.write(merchant);
   writer.write("\" xmlns:em=\"http://www.emailaholic");
   writer.write(".com/xt/1.0\">");
   try
   {
      Class.forName(sqlDriver);
      Connection connection =
         DriverManager.getConnection(sqlURL,
                                     sqlUser,
                                     sqlPassword);
      try
      {
         Statement stmt = connection.createStatement();
         try
         {
            ResultSet rs =
               stmt.executeQuery("select id, name, " +
                  "manufacturer, image, warranty, " +
                  "description, price from products");
            while(rs.next())
            {
               writer.write("<product id=\"");
               writer.write(String.valueOf(rs.getInt(1)));
               writer.write("\"><name>");
               writer.write(rs.getString(2));
               writer.write("</name><em:manufacturer>");
               writer.write(rs.getString(3));
               writer.write("</em:manufacturer><em:image>");
               writer.write(rs.getString(4));
               writer.write("</em:image><em:warranty>");
               writer.write(rs.getString(5));
               writer.write("</em:warranty><description>");
               writer.write(rs.getString(6));
               writer.write("</description><price>");
               writer.write(formatter.format(rs.getDouble(7)));
               writer.write("</price></product>");
            }
         }
         finally
         {
             stmt.close();
         }
      }
      finally
      {
         connection.close();
      }
   }
   catch(ClassNotFoundException e)
   {
      throw new ServletException(e);
   }
   catch(SQLException e)
   {
      throw new ServletException(e);
   }
   writer.write("</products>");
   writer.flush();
}