package com.psol.xcommerce;

/**
 * As the name implies, it signals that something is not yet
 * implemented. It is cleaner than hijacking some other error
 * core. In particular, it saves on debugging! No trying to
 * figure out why something failed when it's not there yet.
 *
 * @version Sep 10, 1999
 * @author Benot Marchal <bmarchal@pineapplesoft.com>
 */

public class NotImplementedError
   extends Error
{
   /**
    * constructs a NotImplementedError with no specified detail message
    */
   public NotImplementedError()
   {
      super();
   }

   /**
    * constructs a NotImplementedError with a detail message
    * @param st detail message
    */
   public NotImplementedError(String st)
   {
      super(st);
   }
}